#include <windows.h>
#include <winternl.h>

#define testtime(HighTime, LowTime) RtlTime.s.HighPart = HighTime; \
           RtlTime.s.LowPart = LowTime; \
           RtlTimeToTimeFields(&RtlTime, &tf); \
           printf("%04d %02d %02d %02d %02d %02d\n", tf.Year, tf.Month, tf.Day,\
                         tf.Hour, tf.Minute, tf.Second);

/* The year to which to test */
#define TargetYear         2222

/* Taken from dlls/ntdll/time.c */
#define EPOCHYEAR          1601
#define TICKSPERSEC        10000000
#define SECSPERDAY         86400
#define MONSPERYEAR        12
static const int MonthLengths[2][MONSPERYEAR] =
{
        { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 },
        { 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 }
};

static inline int IsLeapYear(int Year)
{
        return Year % 4 == 0 && (Year % 100 != 0 || Year % 400 == 0) ? 1 : 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrev, LPSTR lpCmdLine, int cmd)
{
  int Month, Year;
  unsigned long long int time = 0, tmp;

  LARGE_INTEGER RtlTime;
  TIME_FIELDS tf;

  for(Year = 0; Year <= (TargetYear - EPOCHYEAR); Year++) {
    for(Month = 0; Month < MONSPERYEAR; Month++) {
      tmp = MonthLengths[IsLeapYear(Year + EPOCHYEAR)][Month] * SECSPERDAY;
      tmp *= TICKSPERSEC;
      time += tmp;
      testtime(time >> 32, (time & 0xffffffff));
    }
  }

  return;
}

